#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <commdlg.h>
#include <time.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <stdlib.h>

#include <string>
#include <vector>
using namespace std;

#define	    COMPRESSION_NONE        1	/* dump mode */
#define	    COMPRESSION_CCITTRLE    2	/* CCITT modified Huffman RLE */
#define	    COMPRESSION_CCITTFAX3   3	/* CCITT Group 3 fax encoding */
#define	    COMPRESSION_CCITTFAX4   4	/* CCITT Group 4 fax encoding */
#define	    COMPRESSION_LZW         5       /* Lempel-Ziv  & Welch */
#define	    COMPRESSION_JPEG        7	/* %JPEG DCT compression */
#define	    COMPRESSION_PACKBITS    32773	/* Macintosh RLE */
#define	    COMPRESSION_CLASSF      88888888
#define	    COMPRESSION_CLASSF196   88888889

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

typedef void (__stdcall *VeryPDF_PSToImageSetCodeFunc)(const char *lpCode);
typedef BOOL (__stdcall *VeryPDF_PSToImageConverterFunc)(LPCTSTR lpPSFile, LPCTSTR lpImageFile, int nIsWidthAndHeight,
			int xResORWidth, int yResORHeight, int nCompression, BOOL bIsMultiPage,
			int nFirstPage, int nLastPage, int nQuality, int nBitCount, BOOL bGrayscale,
			LPCTSTR lpUserPassword, LPCTSTR lpOwnPassword, BOOL bTransparentBackground);
typedef BOOL (__stdcall *VeryPDF_PSToImageConverter2Func)(LPCTSTR lpPSFile, LPCTSTR lpImageFile, int nIsWidthAndHeight,
			int xResORWidth, int yResORHeight, int nCompression, BOOL bIsMultiPage,
			int nFirstPage, int nLastPage, int nQuality, int nBitCount, BOOL bGrayscale,
			LPCTSTR lpUserPassword, LPCTSTR lpOwnPassword, BOOL bTransparentBackground);
typedef void (__stdcall *VeryPDF_PSToImageSetOptionsFunc)(LPCTSTR ptrKey, LPCTSTR ptrValue);


VeryPDF_PSToImageSetCodeFunc VeryPDF_PSToImageSetCode = NULL;
VeryPDF_PSToImageConverterFunc VeryPDF_PSToImageConverter = NULL;
VeryPDF_PSToImageConverter2Func VeryPDF_PSToImageConverter2 = NULL;
VeryPDF_PSToImageSetOptionsFunc VeryPDF_PSToImageSetOptions = NULL;

HINSTANCE g_hPS2ImageSDK = NULL;

BOOL LoadDLLSDK()
{
	char path[_MAX_PATH];
	GetModulePath(path,"ps2imgsdk.dll");
	g_hPS2ImageSDK = LoadLibrary(path);
	if(g_hPS2ImageSDK == NULL)
		return FALSE;
	VeryPDF_PSToImageSetCode=(VeryPDF_PSToImageSetCodeFunc)GetProcAddress(g_hPS2ImageSDK,"VeryPDF_PSToImageSetCode");
	if(VeryPDF_PSToImageSetCode==NULL)
		return FALSE;
	VeryPDF_PSToImageConverter=(VeryPDF_PSToImageConverterFunc)GetProcAddress(g_hPS2ImageSDK,"VeryPDF_PSToImageConverter");
	if(VeryPDF_PSToImageConverter==NULL)
		return FALSE;
	VeryPDF_PSToImageConverter2=(VeryPDF_PSToImageConverterFunc)GetProcAddress(g_hPS2ImageSDK,"VeryPDF_PSToImageConverter2");
	if(VeryPDF_PSToImageConverter2==NULL)
		return FALSE;
	VeryPDF_PSToImageSetOptions=(VeryPDF_PSToImageSetOptionsFunc)GetProcAddress(g_hPS2ImageSDK,"VeryPDF_PSToImageSetOptions");
	if(VeryPDF_PSToImageSetOptions==NULL)
		return FALSE;
	return TRUE;	
}
void FreeDLLSDK()
{
	if(g_hPS2ImageSDK)
		FreeLibrary(g_hPS2ImageSDK);
}
BOOL PS2ImageConverter(char *lpPSFile, char *lpImgFile, int bTransparentBackground)
{
	char path[_MAX_PATH];
	GetModulePath(path,"ps2imgsdk.dll");
	HINSTANCE hPS2Image = LoadLibrary(path);
	if(hPS2Image == NULL)
		return FALSE;
	VeryPDF_PSToImageSetCode=(VeryPDF_PSToImageSetCodeFunc)GetProcAddress(hPS2Image,"VeryPDF_PSToImageSetCode");
	if(VeryPDF_PSToImageSetCode==NULL)
		return FALSE;
	VeryPDF_PSToImageConverter=(VeryPDF_PSToImageConverterFunc)GetProcAddress(hPS2Image,"VeryPDF_PSToImageConverter");
	if(VeryPDF_PSToImageConverter==NULL)
		return FALSE;
	VeryPDF_PSToImageConverter2=(VeryPDF_PSToImageConverter2Func)GetProcAddress(hPS2Image,"VeryPDF_PSToImageConverter2");
	if(VeryPDF_PSToImageConverter2==NULL)
		return FALSE;

	VeryPDF_PSToImageSetCode("XXXXXXXXXXXXXXXXXXXXXXX");
	int nResult = VeryPDF_PSToImageConverter(lpPSFile,lpImgFile,FALSE,200,200,COMPRESSION_PACKBITS,
		FALSE, -1, -1, 100, 24, FALSE, NULL, NULL, bTransparentBackground);
	
	FreeLibrary(hPS2Image);
	return nResult;
}
int main(int argc, char *argv[])
{
	if(argc != 4)
	{
		printf("Usage: test.exe file.ps file.png 0\n");
		printf("Usage: test.exe file.ps file.png 1\n");
		printf("Usage: test.exe file.ps file.png 2\n");
		return FALSE;
	}
	char *lpPSFile = argv[1];
	char *lpImageFile = argv[2];
	int nTransparentBackground = atoi(argv[3]);
	BOOL nRet = FALSE;
	LoadDLLSDK();
	//nRet = PS2ImageConverter(lpPSFile, lpImageFile, nTransparentBackground);

	VeryPDF_PSToImageSetCode("XXXXXXXXXXXXXXXXXXX");
	
//	nRet = VeryPDF_PSToImageConverter(lpPSFile, lpImageFile, 
//		FALSE,100,100,COMPRESSION_PACKBITS, FALSE, -1, -1, 100, 24, FALSE, NULL, NULL, 0);

	nRet = VeryPDF_PSToImageConverter2(lpPSFile, lpImageFile, 
		FALSE,100,100,COMPRESSION_PACKBITS, FALSE, -1, -1, 100, 24, FALSE, NULL, NULL, 0);
	FreeDLLSDK();
	return nRet;
}